"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const moment = require('moment-timezone');
const child_process_1 = require("child_process");
const TIMEZONE = 'America/New_York';
var weeks = ['2017-09-11', '2017-12-11', '2018-01-29', '2018-03-12', '2018-04-30', '2018-06-11', '2018-07-30', '2018-09-10'];
for (var week of weeks) {
    var localTimeZone = moment.tz(week + " 12:00", TIMEZONE);
    localTimeZone.utcOffset();
    var timeoffset = Math.round(localTimeZone.utcOffset() / 60);
    console.log(`${week} timezone offset ` + timeoffset);
    console.log('filter uber gpsspeed + weekend data + timezone offset');
    child_process_1.execSync(`node bin/run data /data/tiles/dc/u/output_tiles/${week}/events/ --filter-label=gpsspeed --filter-period-max=119 --out=data/u_filtered/${week}/ --timezone-offset=${timeoffset}`);
    console.log('filter lyft + timezone offset');
    child_process_1.execSync(`node bin/run data  /data/tiles/dc/l/sharedstreets_201811/${week}/ --out=data/l_filtered/${week}/ --timezone-offset=${timeoffset}`);
    console.log('filter weekend for lyft');
    child_process_1.execSync(`node bin/run data /data/tiles/dc/l/sharedstreets_201811/${week}/ --out=data/l_scaled/${week}/ --filter-period-min=120 --scale=1.4 --timezone-offset=${timeoffset}`);
    console.log('merge 1');
    child_process_1.execSync(`node bin/run data data/l_filtered/${week}/ --merge=data/u_filtered/${week}/ --out=data/merge1/${week}/`);
    console.log('merge 2');
    child_process_1.execSync(`node bin/run data data/merge1/${week}/ --merge=data/l_scaled/${week}/ --out=data/merge_final/${week}/`);
}
